clang 10.0.0git

Macros | Functions
MIGChecker.cpp File Reference
`#include "clang/AST/Attr.h"`
`#include "clang/Analysis/AnyCall.h"`
`#include "clang/StaticAnalyzer/Checkers/BuiltinCheckerRegistration.h"`
`#include "clang/StaticAnalyzer/Core/BugReporter/BugType.h"`
`#include "clang/StaticAnalyzer/Core/Checker.h"`
`#include "clang/StaticAnalyzer/Core/CheckerManager.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/CallEvent.h"`
`#include "clang/StaticAnalyzer/Core/PathSensitive/CheckerContext.h"`
Include dependency graph for MIGChecker.cpp:

Go to the source code of this file.

## Macros
#define | CALL(required_args, deallocated_arg, ...) {{{__VA_ARGS__}, required_args}, deallocated_arg}

## Functions
static const ParmVarDecl * | getOriginParam (SVal V, CheckerContext &C, bool IncludeBaseRegions=false)
static bool | isInMIGCall (CheckerContext &C)
static bool | mayBeSuccess (SVal V, CheckerContext &C)

## Macro Definition Documentation

## ◆ CALL

#define CALL | ( |  | required_args,
|  |  | deallocated_arg,
|  |  | ...
| ) |  | {{{__VA_ARGS__}, required_args}, deallocated_arg}

## Function Documentation

## ◆ getOriginParam()

static const ParmVarDecl* getOriginParam | ( | SVal | V,
|  | CheckerContext & | C,
|  | bool | IncludeBaseRegions = `false`
| ) |  |
| static

Definition at line 118 of file MIGChecker.cpp.

Referenced by isInMIGCall().

## ◆ isInMIGCall()

static bool isInMIGCall | ( | CheckerContext & | C | ) |
| static

Definition at line 146 of file MIGChecker.cpp.

References clang::LocationContext::getDecl(), clang::NamedDecl::getName(), getOriginParam(), clang::LocationContext::getParent(), clang::LocationContext::getStackFrame(), clang::Decl::hasAttr(), clang::ento::OS, and State.

Referenced by mayBeSuccess().

## ◆ mayBeSuccess()

static bool mayBeSuccess | ( | SVal | V,
|  | CheckerContext & | C
| ) |  |
| static

Definition at line 226 of file MIGChecker.cpp.

References clang::ReturnStmt::getRetValue(), clang::Stmt::getSourceRange(), clang::ASTContext::IntTy, isInMIGCall(), State, and V.